## cancomm 1.0.0

=== CMakeLists.txt ===
# Specify the minimum version.
cmake_minimum_required(VERSION 3.9)

# Specify the project info.
project(cancomm LANGUAGES C VERSION 1.0.0 DESCRIPTION "SocketCAN communication library")

# For access to standard installation directory variables (CMAKE_INSTALL_xDIR).
include(GNUInstallDirs)

# Declare the library target.
add_library(${PROJECT_NAME} SHARED
    source/cancomm.c
    source/cancomm.h
)

# Set the version property.
set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION})

# Set the shared object version property to the project's major version. This results
# in a cancomm.so.1 symlink to cancomm.so.1.0.0 in the example case of version 1.0.0.
set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR})

# Set the public header property to the one with the actual API.
set_target_properties(${PROJECT_NAME} PROPERTIES PUBLIC_HEADER source/cancomm.h)

# Configure the directories to search for header files.
target_include_directories(${PROJECT_NAME} PRIVATE source)

# Create the pkg-config file from the template.
configure_file(source/${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc @ONLY)

# Set library shared object and API header file to install.
install(TARGETS ${PROJECT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Set pkg-config file to install.
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== example/CMakeLists.txt ===
# Specify the minimum version.
cmake_minimum_required(VERSION 3.9)

# Specify the project info.
project(example LANGUAGES C VERSION 1.0.0 DESCRIPTION "SocketCAN communication library example")

# Finds the pkg-config executable adds the pkg_check_modules() function, among others.
find_package(PkgConfig REQUIRED)

# Create imported target with name PkgConfig::CANCOMM
pkg_check_modules(CANCOMM REQUIRED IMPORTED_TARGET cancomm)

# Declare the executable target.
add_executable(${PROJECT_NAME} example.c)

# Specify the libraries to use when linking the target.
target_link_libraries(${PROJECT_NAME} PUBLIC PkgConfig::CANCOMM)

=== debian/changelog ===
cancomm (1.0.0-1) UNRELEASED; urgency=low

  * Initial packaging of version 1.0.0.

 -- PragmaticLinux <info@pragmaticlinux.com>  Fri, 18 Mar 2022 17:37:51 +0100

=== debian/control ===
Source: cancomm
Section: libs
Priority: optional
Maintainer: PragmaticLinux <info@pragmaticlinux.com>
Build-Depends: cmake, debhelper-compat (= 12)
Standards-Version: 4.5.0
Homepage: https://github.com/pragmaticlinuxblog/cancomm

Package: libcancomm1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SocketCAN communication library
 A library for convenient access to CAN communication, based on the
 SocketCAN kernel functionality.
  
Package: libcancomm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libcancomm1 (= ${binary:Version})
Description: SocketCAN communication library (development files)
 A library for convenient access to CAN communication, based on the
 SocketCAN kernel functionality.
 .
 This package provides development libraries and headers.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@  

override_dh_strip:
	dh_strip --no-automatic-dbgsym
